package org.arkerthan.sanityCheck.element;

/**
 * @author Arkerthan
 */
public class KnownTwineElement extends KnownElement {

	private boolean opening;
	private String statement;

	/**
	 * @param line	  at which it begins
	 * @param pos	   at which it begins
	 * @param opening   if it opens a tag: <<tag>>  or closes it: <</tag>>
	 * @param statement statement inside the tag
	 */
	public KnownTwineElement(int line, int pos, boolean opening, String statement) {
		super(line, pos);
		this.opening = opening;
		this.statement = statement;
	}

	@Override
	public String getShortDescription() {
		StringBuilder builder = new StringBuilder();
		builder.append(getPositionAsString()).append(" <<");
		if (!opening) {
			builder.append("/");
		}
		return builder.append(statement).append(">>").toString();
	}

	@Override
	public boolean isOpening() {
		return opening;
	}

	@Override
	public boolean isClosing() {
		return !opening;
	}

	@Override
	public boolean isMatchingElement(KnownElement k) {
		if (k instanceof KnownTwineElement) {
			return ((KnownTwineElement) k).statement.equals(this.statement);
		}
		return false;
	}
}
