/* OPEN MAIN */
App.UI.View.MainLinks = function() {
	"use strict";
	const V = State.variables;
	const PA = Array.isArray(V.personalAttention) ? V.personalAttention.map(function(x) {
		return getSlave(x.ID);
	}) : [];
	let r = ``;
	if (V.HeadGirl) {
		/* eslint-disable */
		const pronouns = getPronouns(V.HeadGirl);
		const he = pronouns.pronoun;
		const him = pronouns.object;
		const his = pronouns.possessive;
		const hers = pronouns.possessivePronoun;
		const himself = pronouns.objectReflexive;
		const boy = pronouns.noun;
		const He = capFirstChar(he);
		const His = capFirstChar(his);
		/* eslint-enable */
	}

	if (V.PCWounded === 1) {
		r += `The injuries received in the recent battle prevent you from undertaking tiring efforts.`;
	} else {
		switch (V.personalAttention) {
			case "business":
				r += `You plan to focus on business this week.`;
				break;
			case "whoring":
				r += `You plan to focus on earning extra money this week.`;
				break;
			case "upkeep":
				r += `You plan to focus on cleaning the penthouse this week.`;
				break;
			case "smuggling":
				r += `You plan to make some easy (but dirty) money this week.`;
				break;
			case "HG":
				r += `You plan to support your Head Girl this week, so ${he} can give more slaves ${his} attention.`;
				break;
			case "sex":
				r += `You plan to have as much sex with your slaves as possible this week.`;
				break;
			case "trading":
				r += `This week you will learn trading.`;
				break;
			case "warfare":
				r += `This week you will learn modern combat tactics.`;
				break;
			case "slaving":
				r += `This week you will learn slaving.`;
				break;
			case "engineering":
				r += `This week you will learn engineering.`;
				break;
			case "medicine":
				r += `This week you will learn medicine.`;
				break;
			case "hacking":
				r += `This week you will learn hacking.`;
				break;
			case "proclamation":
				r += `This week you plan to issue a proclamation about ${V.proclamationType}.`;
				break;
			case "technical accidents":
				r += `This week you plan to sell your technical skills to the highest bidder.`;
				break;
			default:
				if (PA.length > 0) {
					r += `You plan to train `;
					let l = PA.length;
					for (let dwi = 0; dwi < l; dwi++) {
						if (dwi > 0 && dwi === l - 1) {
							r += ` and `;
						}
						r += `<strong><u><span class="pink">${SlaveFullName(PA[dwi])}</span></u></strong> to ${V.personalAttention[dwi].trainingRegimen}`;
						if (dwi > 0 && dwi < l - 2) {
							r += `,`;
						}
					}
					r += ` this week.`;
				}
				break;
		}
	}

	if (V.PCWounded !== 1) {
		r += ` <span id="managePA"><strong><<link "Change plans">><<goto "Personal Attention Select">><</link>></strong></span> <span class="cyan">[A]</span>`;
	}

	if (V.useSlaveSummaryOverviewTab !== 1) {
		if (typeof V.slaveIndices[V.HeadGirl.ID] !== 'undefined') {
			r += `<br><strong><u><span class="pink">${SlaveFullName(V.HeadGirl)}</span></u></strong> is serving as your Head Girl`;
			if (V.arcologies[0].FSEgyptianRevivalistLaw === 1) {
				r += ` and Consort`;
			}
			r += `. <span id="manageHG"><strong><<link "Manage Head Girl">><<goto "HG Select">><</link>></strong></span> <span class="cyan">[H]</span>`;
		} else if (typeof V.slaveIndices[V.HeadGirl.ID] === 'undefined' && (V.slaves.length > 1)) {
			r += `<br>You have not selected a Head Girl`;
			if (V.arcologies[0].FSEgyptianRevivalistLaw === 1) {
				r += ` and Consort`;
			}
			r += `. <span id="manageHG"><strong><<link "Select one">><<goto "HG Select">><</link>></strong></span> <span class="cyan">[H]</span>`;
		} else if (typeof V.slaveIndices[V.HeadGirl.ID] === 'undefined') {
			r += `//You do not have enough slaves to keep a Head Girl//`;
		}
		r += `<br>`;

		if (typeof V.slaveIndices[V.Recruiter.ID] !== 'undefined') {
			r += `<strong><u><span class="pink">${SlaveFullName(V.Recruiter)}</span></u></strong> is working to recruit girls. <span id="manageRecruiter"><strong><<link "Manage Recruiter">><<goto "Recruiter Select">><</link>></strong></span> <span class="cyan">[U]</span>`;
		} else {
			r += `You have not selected a Recruiter. <span id="manageRecruiter"><strong><<link "Select one">><<goto "Recruiter Select">><</link>></strong></span> <span class="cyan">[U]</span>`;
		}

		if (V.dojo) {
			r += `<br>`;
			if (typeof V.slaveIndices[V.Bodyguard.ID] !== 'undefined') {
				r += `<strong><u><span class="pink">${SlaveFullName(V.Bodyguard)}</span></u></strong> is serving as your bodyguard. <span id="manageBG"><strong><<link "Manage Bodyguard">><<goto "BG Select">><</link>></strong></span> <span class="cyan">[B]</span>`;
			} else {
				r += `You have not selected a Bodyguard. <span id="manageBG"><strong><<link "Select one">><<goto "BG Select">><</link>></strong></span> <span class="cyan">[B]</span>`;
			}
		}
	}

	if (V.completedOrgans.length > 0) {
		/* first remove any organs with no corresponding slave */
		V.completedOrgans = V.completedOrgans.filter(organ => {
			return (typeof organ === 'object' && getSlave(organ.ID) !== undefined);
		});
		/* cycle through slaves, for each slave cycle through completed organs and track how many are of the interrogated slave (and if organs have a slaves to be implanted on) */
		for (let i = 0; i < V.slaves.length; i++) {
			let slaveOrgans = 0;
			V.completedOrgans.forEach(organ => {
				if (organ.ID === V.slaves[i].ID)
					slaveOrgans++;
			});
			/* if the interrogated slave has one or more organs ready: */
			if (slaveOrgans > 0) {
				r += '<br><span class="yellow">The fabricator has completed ';
				if (slaveOrgans > 1) {
					r += `${slaveOrgans} organs`;
				} else {
					r += 'an organ';
				}
				r += ` for </span><<link "<<print $slaves[${i}].slaveName>>">><<set $activeSlave = $slaves[${i}]>><<goto "Slave Interact">><</link>>, <span class="yellow"> which `;
				if (slaveOrgans > 1) {
					r += 'are';
				} else {
					r += 'is';
				}
				r += ' ready to be implanted.</span>';
			}
		}
	}

	if (V.adjustProstheticsCompleted > 0) {
		for (let j = 0; j < V.adjustProsthetics.length; j++) {
			if (getSlave(V.adjustProsthetics[j].slaveID) !== undefined) {
				let i = V.slaveIndices[V.adjustProsthetics[j].slaveID];
				if (V.adjustProsthetics[j].workLeft <= 0) {
					r += `<br><span class="yellow">The lab has completed <<= addA(setup.prosthetics[$adjustProsthetics[${j}].id].name)>> for</span> <span id="name"><<= "[[SlaveFullName($slaves[${i}])|Slave Interact][$activeSlave = $slaves[${i}]]]">>,</span> <span class="yellow"> which is ready to be attached.</span>`;
				}
			} else {
				V.adjustProsthetics.splice(j, 1);
				j--;
			}
		}
	}

	if (V.completedOrgans.length > 0 && V.adjustProstheticsCompleted > 0) {
		r += `<br>[[Implant and Attach|Multiple Organ Implant]] <span class="yellow">all organs and prosthetics that are ready.</span>`;
	} else if (V.completedOrgans.length > 0) {
		r += `<br>[[Implant|Multiple Organ Implant]] <span class="yellow">all organs that are ready for implantation.</span>`;
	} else if (V.adjustProstheticsCompleted > 0) {
		r += `<br>[[Attach|Multiple Organ Implant]] <span class="yellow">all prosthetics that are ready to be attached.</span>`;
	}

	if (V.slaveCostFactor > 1.05) {
		r += `<br><span class="yellow">There is a bull market for slaves; the price of slaves is very high.</span>`;
	} else if (V.slaveCostFactor > 1) {
		r += `<br><span class="yellow">The slave market is bullish; the price of slaves is high.</span>`;
	} else if (V.slaveCostFactor < 0.95) {
		r += `<br><span class="yellow">There is a bear market for slaves; the price of slaves is very low.</span>`;
	} else if (V.slaveCostFactor < 1) {
		r += `<br><span class="yellow">The slave market is bearish; the price of slaves is low.</span>`;
	} else {
		r += `<br>The slave market is stable; the price of slaves is average.`;
	}

	r += ` <span id="buySlaves"><strong><<link "Buy Slaves">><<goto "Buy Slaves">><</link>></strong></span> <span class="cyan">[S]</span>`;
	if (V.TSS.schoolSale !== 0) {
		r += `<br><span class="yellow">For your first purchase, </span><strong>[[The Slavegirl School][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
	}
	if (V.GRI.schoolSale !== 0) {
		r += `<br><span class="yellow">For your first purchase, </span><strong>[[Growth Research Institute][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
	}
	if (V.SCP.schoolSale !== 0) {
		r += `<br><span class="yellow">For your first purchase, </span><strong>[[St. Claver Preparatory][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
	}
	if (V.TCR.schoolSale !== 0) {
		r += `<br><span class="yellow">For your first purchase, </span><strong>[[The Cattle Ranch][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
	}
	if (V.HA.schoolSale !== 0) {
		r += `<br><span class="yellow">For your first purchase, </span><strong>[[The Hippolyta Academy][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
	}

	if (V.seeDicks !== 0) {
		if (V.LDE.schoolSale !== 0) {
			r += `<br><span class="yellow">For your first purchase, </span><strong>[[L'École des Enculées][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
		}
		if (V.TGA.schoolSale !== 0) {
			r += `<br><span class="yellow">For your first purchase, </span><strong>[[The Gymnasium-Academy][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
		}
		if (V.TFS.schoolSale !== 0) {
			r += `<br><span class="yellow">For your first purchase, </span><strong>[[The Futanari Sisters][$slavesSeen += 1]]</strong><span class="yellow"> will sell at half price this week.</span>`;
		}
	}
	return r;
};
/* CLOSE MAIN */
