Macro.add("colorinput", {
	handler: function() {
		if (this.args.length < 2) {
			let e = [];
			return this.args.length < 1 && e.push("variable name"), this.args.length < 2 && e.push("default value"), this.error("no " + e.join(" or ") + " specified");
		}
		if ("string" !== typeof this.args[0]) return this.error("variable name argument is not a string");
		let varName = this.args[0].trim();
		if ("$" !== varName[0] && "_" !== varName[0]) return this.error('variable name "' + this.args[0] + '" is missing its sigil ($ or _)');
		Config.debug && this.debugView.modes({
			block: true
		});
		let r = Util.slugify(varName);
		let value = this.args[1];
		let inputElement = document.createElement("input"),
			passage = void 0;
		let setargs = null;
		if (this.args.length > 3) {
			passage = this.args[2];
		} else if (this.args.length > 2) {
			passage = this.args[2];
		}
		if (passage !== (void 0) && typeof (passage) === "object") {
			passage = passage.link;
		}
		if (!passage) {
			passage = State.passage;
		}

		function gotoPassage() {
			if (passage) {
				let currentScrollPosition = window.pageYOffset;
				const currentPassage = State.passage;
				if (setargs) {
					Scripting.evalTwineScript(setargs);
				}
				Engine.play(passage);
				if (currentPassage === passage) {
					Scripting.evalJavaScript("window.scrollTo(0, " + currentScrollPosition + ");");
				}
			}
		}

		jQuery(inputElement).attr({
				id: this.name + "-" + r,
				name: this.name + "-" + r,
				type: 'color',
				value: value,
				tabindex: 0
			}).addClass("macro-" + this.name)
			.on("change", function() {
				State.setVar(varName, this.value);
				// eslint-disable-next-line eqeqeq
				if (this.value != value) { // If the value has actually changed, reload the page.  Note != and not !== because types might be different
					gotoPassage();
				}
			})
			.appendTo(this.output);
	}
});
